using System;
using System.Collections.Generic;
using System.Text;
using Cryptware.NDigitSign;

namespace TestNDigitSign
{
    class Program
    {
        static void Main(string[] args)
        {
			// Sets license info
			DigitalSigner.Licensee = "licensee";
            DigitalSigner.ProductKey = "yourproductkey";
			
			// Gets the right cryptoki path based on the ATR of the card
			string cryptokiPath = DigitalSigner.GetMatchingCryptokiName();

            DigitalSigner dsign = new DigitalSigner(cryptokiPath);

            // open a session taking the first available READER
            dsign.OpenSession(0);
            
            // login
            dsign.Login("12345678");
            
			// CADES signature 

            // creates a TSA client
            TSAClient tsaClient = new TSAClient("http://tsa.aloaha.com/");

			// set signature parameters
            dsign.CAdES = true;
            dsign.Detached = false;
            dsign.Multisignature = true;
			dsign.TSAClient = tsaClient;

			// we use SimpleCertificateSelector, 
			// for qualified digital signature use QualifiedCertificateSelector
            // N.B. you can implement your own CertificateSelector for yor specific way to select a certificate
			SignedDocument signedDocument = dsign.Sign(Encoding.Default.GetBytes("text to sign"),new SimpleCertificateSelector());

            bool b = signedDocument.Verify();
        }
    }
}
